Difference between revisions of "Code snippets/fr"

From FreeCAD Documentation
Jump to: navigation, search
(Updating to match new version of source page)
(Updating to match new version of source page)
Line 1: Line 1:
 
<languages/>
 
<languages/>
 +
<div class="mw-translate-fuzzy">
 
{{docnav/fr|[[Embedding FreeCAD/fr|Embedding FreeCAD]]|[[Line drawing function/fr|Line drawing function]]}}
 
{{docnav/fr|[[Embedding FreeCAD/fr|Embedding FreeCAD]]|[[Line drawing function/fr|Line drawing function]]}}
 +
</div>
  
 
{{TutorialInfo/fr
 
{{TutorialInfo/fr
Line 18: Line 20:
  
 
Ceci est un simple exemple.  
 
Ceci est un simple exemple.  
 +
 
{{Code|code=
 
{{Code|code=
 
class ScriptWorkbench (Workbench):  
 
class ScriptWorkbench (Workbench):  
Line 33: Line 36:
 
Ceci est l'exemple d'un fichier module principal, il contient tout ce que fait votre module. C'est le fichier '''Scripts.py''' invoqué dans l'exemple précédent.  
 
Ceci est l'exemple d'un fichier module principal, il contient tout ce que fait votre module. C'est le fichier '''Scripts.py''' invoqué dans l'exemple précédent.  
 
Vous avez ici toutes vos commandes personnalisées.
 
Vous avez ici toutes vos commandes personnalisées.
 +
 
{{Code|code=
 
{{Code|code=
 
  import FreeCAD, FreeCADGui  
 
  import FreeCAD, FreeCADGui  
Line 53: Line 57:
  
 
Cette ligne doit être ajoutée au fichier '''InitGui.py''' pour ajouter la nouvelle extension de fichier à la liste:
 
Cette ligne doit être ajoutée au fichier '''InitGui.py''' pour ajouter la nouvelle extension de fichier à la liste:
 +
 
{{Code|code=
 
{{Code|code=
 
# Assumes Import_Ext.py is the file that has the code for opening and reading .ext files
 
# Assumes Import_Ext.py is the file that has the code for opening and reading .ext files
 
FreeCAD.addImportType("Your new File Type (*.ext)","Import_Ext")  
 
FreeCAD.addImportType("Your new File Type (*.ext)","Import_Ext")  
 
}}
 
}}
 +
 
Puis, dans le fichier '''Import_Ext.py''', faites:
 
Puis, dans le fichier '''Import_Ext.py''', faites:
 +
 
{{Code|code=
 
{{Code|code=
 
def open(filename):  
 
def open(filename):  
Line 64: Line 71:
 
   doc.recompute()
 
   doc.recompute()
 
}}
 
}}
 +
 
Pour exporter votre document avec une  nouvelle extension, le fonctionnement est le même, mais vous devrez faire:
 
Pour exporter votre document avec une  nouvelle extension, le fonctionnement est le même, mais vous devrez faire:
  
Line 70: Line 78:
 
=== Ajouter une ligne ===
 
=== Ajouter une ligne ===
 
Une ligne, à uniquement deux points.
 
Une ligne, à uniquement deux points.
 +
 
{{Code|code=
 
{{Code|code=
  
Line 84: Line 93:
 
=== Ajouter un polygone ===
 
=== Ajouter un polygone ===
 
Un polygone est simplement un ensemble de segments connnectés (un polyline dans AutoCAD) il n'est pas obligatoirement fermé.
 
Un polygone est simplement un ensemble de segments connnectés (un polyline dans AutoCAD) il n'est pas obligatoirement fermé.
 +
 
{{Code|code=
 
{{Code|code=
 
import Part,PartGui  
 
import Part,PartGui  
Line 101: Line 111:
  
 
=== Ajout et suppression d'objet(s) dans un groupe ===
 
=== Ajout et suppression d'objet(s) dans un groupe ===
 +
 
{{Code|code=
 
{{Code|code=
 
doc=App.activeDocument()  
 
doc=App.activeDocument()  
Line 108: Line 119:
 
grp.removeObject(lin) # removes the lin object from the group grp
 
grp.removeObject(lin) # removes the lin object from the group grp
 
}}
 
}}
 +
 
'''PS:''' vous pouvez aussi ajouter un groupe dans un groupe . . .
 
'''PS:''' vous pouvez aussi ajouter un groupe dans un groupe . . .
  
 
=== Ajout d'une maille (Mesh) ===
 
=== Ajout d'une maille (Mesh) ===
 +
 
{{Code|code=
 
{{Code|code=
 
import Mesh
 
import Mesh
Line 137: Line 150:
  
 
=== Ajout d'un arc ou d'un cercle ===
 
=== Ajout d'un arc ou d'un cercle ===
 +
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
Line 150: Line 164:
  
 
Chaque objet dans un document FreeCAD a un objet '''vue''' associé a une '''représentation''' qui stocke tous les paramètres qui définissent les propriétés de l'objet, comme, la couleur, l'épaisseur de la ligne, etc ..
 
Chaque objet dans un document FreeCAD a un objet '''vue''' associé a une '''représentation''' qui stocke tous les paramètres qui définissent les propriétés de l'objet, comme, la couleur, l'épaisseur de la ligne, etc ..
 +
 
{{Code|code=
 
{{Code|code=
 
gad=Gui.activeDocument()  # access the active document containing all  
 
gad=Gui.activeDocument()  # access the active document containing all  
Line 164: Line 179:
 
Par défaut, FreeCAD, possède un noeud (node) de rappel installé par la visionneuse (fenêtre d'affichage des graphes), qui permet d'ajouter des fonctions statiques ou globales en C++.
 
Par défaut, FreeCAD, possède un noeud (node) de rappel installé par la visionneuse (fenêtre d'affichage des graphes), qui permet d'ajouter des fonctions statiques ou globales en C++.
 
Des méthodes de liaisons appropriées sont fournies avec Python, pour permettre l'utilisation de cette technique à partir de codes Python.
 
Des méthodes de liaisons appropriées sont fournies avec Python, pour permettre l'utilisation de cette technique à partir de codes Python.
 +
 
{{Code|code=
 
{{Code|code=
 
App.newDocument()
 
App.newDocument()
Line 180: Line 196:
 
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)
 
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)
 
}}
 
}}
 +
 
Maintenant, choisissez une zone dans l'écran (surface de travail) 3D et observez les messages affichés dans la fenêtre de sortie. Pour terminer l'observation il suffit de faire:
 
Maintenant, choisissez une zone dans l'écran (surface de travail) 3D et observez les messages affichés dans la fenêtre de sortie. Pour terminer l'observation il suffit de faire:
 +
 
{{Code|code=
 
{{Code|code=
 
v.removeEventCallback("SoMouseButtonEvent",c)
 
v.removeEventCallback("SoMouseButtonEvent",c)
 
}}
 
}}
 +
 
Les types d’évènements suivants sont pris en charge:
 
Les types d’évènements suivants sont pris en charge:
 
* SoEvent -- tous types d'évènements
 
* SoEvent -- tous types d'évènements
Line 223: Line 242:
 
===Afficher les évènements claviers et commandes===
 
===Afficher les évènements claviers et commandes===
 
Cette macro affiche dans la vue du rapport les touches enfoncées et tous les événements commande  
 
Cette macro affiche dans la vue du rapport les touches enfoncées et tous les événements commande  
 +
 
{{Code|code=
 
{{Code|code=
 
App.newDocument()
 
App.newDocument()
Line 241: Line 261:
 
#v.removeEventCallback("SoEvent",c) # remove ViewObserver
 
#v.removeEventCallback("SoEvent",c) # remove ViewObserver
 
}}
 
}}
 +
 
=== Manipulation de scènes graphiques en Python ===
 
=== Manipulation de scènes graphiques en Python ===
  
 
Il est aussi possible d'afficher ou de changer de scène en programmation Python, avec le module [[pivy/fr|pivy]] en combinaison avec [http://www.coin3d.org/ Coin]
 
Il est aussi possible d'afficher ou de changer de scène en programmation Python, avec le module [[pivy/fr|pivy]] en combinaison avec [http://www.coin3d.org/ Coin]
 +
 
{{Code|code=
 
{{Code|code=
 
from pivy.coin import *                # load the pivy module
 
from pivy.coin import *                # load the pivy module
Line 251: Line 273:
 
view.fitAll()
 
view.fitAll()
 
}}
 
}}
 +
 
L'API Python de pivy est créé en utilisant l'outil [http://www.swig.org/ SWIG]. Comme dans FreeCAD nous utilisons certains noeuds (nodes) écrits automatiquement nous ne pouvons pas les créer directement en Python.
 
L'API Python de pivy est créé en utilisant l'outil [http://www.swig.org/ SWIG]. Comme dans FreeCAD nous utilisons certains noeuds (nodes) écrits automatiquement nous ne pouvons pas les créer directement en Python.
 
Il est cependant, possible de créer un noeud avec son nom interne.
 
Il est cependant, possible de créer un noeud avec son nom interne.
 
Un exemple de SoFCSelection, le type peut être créé avec:
 
Un exemple de SoFCSelection, le type peut être créé avec:
 +
 
{{Code|code=
 
{{Code|code=
 
type = SoType.fromName("SoFCSelection")
 
type = SoType.fromName("SoFCSelection")
Line 263: Line 287:
 
Ajouter de nouveaux noeuds dans la scène graphique peut être fait de cette façon. Prenez toujours soin d'ajouter un '''SoSeparator''' pour, contenir les propriétés de la forme géométrique, les coordonnées et le matériel d'un même objet.  
 
Ajouter de nouveaux noeuds dans la scène graphique peut être fait de cette façon. Prenez toujours soin d'ajouter un '''SoSeparator''' pour, contenir les propriétés de la forme géométrique, les coordonnées et le matériel d'un même objet.  
 
L'exemple suivant ajoute une ligne rouge à partir de (0,0,0) à (10,0,0):
 
L'exemple suivant ajoute une ligne rouge à partir de (0,0,0) à (10,0,0):
 +
 
{{Code|code=
 
{{Code|code=
 
from pivy import coin
 
from pivy import coin
Line 279: Line 304:
 
sg.addChild(no)
 
sg.addChild(no)
 
}}
 
}}
 +
 
Pour le supprimer, il suffit de:
 
Pour le supprimer, il suffit de:
 
{{Code|code=
 
{{Code|code=
 
sg.removeChild(no)
 
sg.removeChild(no)
 
}}
 
}}
 +
 
===Enregistre la vue 3Den pratiquant une rotation dans une série de 36 fichiers dans les axes X Y Z===
 
===Enregistre la vue 3Den pratiquant une rotation dans une série de 36 fichiers dans les axes X Y Z===
  
Line 364: Line 391:
  
 
Le code python produit par le compilateur python Ui (l'outil qui convertit les fichiers .ui de qt-designer en code python) généralement codé comme ceci (il est simple, vous pouvez aussi le coder directement en Python):
 
Le code python produit par le compilateur python Ui (l'outil qui convertit les fichiers .ui de qt-designer en code python) généralement codé comme ceci (il est simple, vous pouvez aussi le coder directement en Python):
 +
 
{{Code|code=
 
{{Code|code=
 
class myWidget_Ui(object):
 
class myWidget_Ui(object):
Line 378: Line 406:
 
         self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))
 
         self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))
 
}}
 
}}
 +
 
Puis, vous devez créer une référence à la fenêtre FreeCAD Qt, lui insérer le widget personnalisé, et transférer le code Ui du widget que nous venons de faire dans le vôtre avec:
 
Puis, vous devez créer une référence à la fenêtre FreeCAD Qt, lui insérer le widget personnalisé, et transférer le code Ui du widget que nous venons de faire dans le vôtre avec:
 +
 
{{Code|code=
 
{{Code|code=
 
app = QtGui.qApp
 
app = QtGui.qApp
Line 391: Line 421:
 
===Ajout d'une liste déroulante===
 
===Ajout d'une liste déroulante===
 
Le code suivant vous permet d'ajouter une liste déroulante dans FreeCAD, en plus des onglets "Projet" et "tâches". Il utilise également le module uic pour charger un fichier ui directement dans cet onglet.
 
Le code suivant vous permet d'ajouter une liste déroulante dans FreeCAD, en plus des onglets "Projet" et "tâches". Il utilise également le module uic pour charger un fichier ui directement dans cet onglet.
 +
 
{{Code|code=
 
{{Code|code=
 
# create new Tab in ComboView
 
# create new Tab in ComboView
Line 426: Line 457:
  
 
}}
 
}}
 +
 
===Activer ou désactiver une fenêtre===
 
===Activer ou désactiver une fenêtre===
 +
 
{{Code|code=
 
{{Code|code=
 
from PySide import QtGui
 
from PySide import QtGui
Line 452: Line 485:
  
 
===Ouverture d'une page web===
 
===Ouverture d'une page web===
 +
 
{{Code|code=
 
{{Code|code=
 
import WebGui
 
import WebGui
Line 458: Line 492:
  
 
===Obtenir le code HTML d'une page Web ouverte===
 
===Obtenir le code HTML d'une page Web ouverte===
 +
 
{{Code|code=
 
{{Code|code=
 
from PySide import QtGui,QtWebKit
 
from PySide import QtGui,QtWebKit
Line 468: Line 503:
  
 
===Extraire et utiliser les coordonnées de 3 points sélectionnés===
 
===Extraire et utiliser les coordonnées de 3 points sélectionnés===
 +
 
{{Code|code=
 
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
Line 495: Line 531:
  
 
===Lister les objets===
 
===Lister les objets===
 +
 
{{Code|code=
 
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
Line 515: Line 552:
 
#doc.removeObject("Box") # Clears the designated object
 
#doc.removeObject("Box") # Clears the designated object
 
}}
 
}}
 +
 
===Lister les dimensions en donnant le nom de l'objet===
 
===Lister les dimensions en donnant le nom de l'objet===
 +
 
{{Code|code=
 
{{Code|code=
 
for edge in FreeCAD.ActiveDocument.MyObjectName.Shape.Edges: # replace "MyObjectName" for list
 
for edge in FreeCAD.ActiveDocument.MyObjectName.Shape.Edges: # replace "MyObjectName" for list
Line 521: Line 560:
 
}}
 
}}
  
 +
===Fonction résidente avec action au clic de souris===
  
===Fonction résidente avec action au clic de souris===
 
 
Here with '''SelObserver''' on a object select
 
Here with '''SelObserver''' on a object select
 +
 
{{Code|code=
 
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
Line 555: Line 595:
  
 
Other example with '''ViewObserver''' on a object select or view
 
Other example with '''ViewObserver''' on a object select or view
 +
 
{{Code|code=
 
{{Code|code=
 
App.newDocument()
 
App.newDocument()
Line 579: Line 620:
  
 
}}
 
}}
 +
 
===Recherche et sélection de tous les éléments sous le curseur===
 
===Recherche et sélection de tous les éléments sous le curseur===
 +
 
{{Code|code=
 
{{Code|code=
 
from pivy import coin
 
from pivy import coin
Line 619: Line 662:
  
 
===Lister les composantes d'un objet===
 
===Lister les composantes d'un objet===
 +
 
{{Code|code=
 
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
Line 718: Line 762:
  
 
===Lister les PropertiesList===
 
===Lister les PropertiesList===
 +
 
{{Code|code=
 
{{Code|code=
 
import FreeCADGui
 
import FreeCADGui
Line 726: Line 771:
 
     Console.PrintMessage("Property: "+ str(p)+ " Value: " + str(o.getPropertyByName(p))+"\r\n")
 
     Console.PrintMessage("Property: "+ str(p)+ " Value: " + str(o.getPropertyByName(p))+"\r\n")
 
}}
 
}}
 +
 
===Ajouter une Propriété "Commentaire"===
 
===Ajouter une Propriété "Commentaire"===
 +
 
{{Code|code=
 
{{Code|code=
 
import Draft
 
import Draft
Line 741: Line 788:
  
 
L'affichage se fait dans la vue rapport (Menu Affichage → Vues → Vue rapport)
 
L'affichage se fait dans la vue rapport (Menu Affichage → Vues → Vue rapport)
 +
 
{{Code|code=
 
{{Code|code=
 
# -*- coding: utf-8 -*-
 
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
 
from __future__ import unicode_literals
 
from __future__ import unicode_literals
Line 757: Line 803:
 
# Displayed on Report view : Menu View > Views > report view
 
# Displayed on Report view : Menu View > Views > report view
 
#
 
#
# rev:30/08/2014:29/09/2014:17/09/2015
+
# rev:30/08/2014:29/09/2014:17/09/2015 22/11/2019
 
   
 
   
 
from FreeCAD import Base
 
from FreeCAD import Base
 
import DraftVecUtils, Draft, Part
 
import DraftVecUtils, Draft, Part
+
 
 +
# search the name of the active document
 
mydoc = FreeCAD.activeDocument().Name                                    # Name of active Document
 
mydoc = FreeCAD.activeDocument().Name                                    # Name of active Document
 
App.Console.PrintMessage("Active docu    : "+(mydoc)+"\n")
 
App.Console.PrintMessage("Active docu    : "+(mydoc)+"\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# search the label of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
object_Label = sel[0].Label                                              # Label of the object (modifiable)
 
object_Label = sel[0].Label                                              # Label of the object (modifiable)
 
App.Console.PrintMessage("object_Label  : "+(object_Label)+"\n")
 
App.Console.PrintMessage("object_Label  : "+(object_Label)+"\n")
 
##################################################################################
 
##################################################################################
+
 
 +
#TypeID object FreeCAD selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
App.Console.PrintMessage("sel            : "+str(sel[0])+"\n\n")          # sel[0] first object selected
 
App.Console.PrintMessage("sel            : "+str(sel[0])+"\n\n")          # sel[0] first object selected
 
##################################################################################
 
##################################################################################
+
 
 +
# search the Name of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
object_Name  = sel[0].Name                                                # Name of the object (not modifiable)
 
object_Name  = sel[0].Name                                                # Name of the object (not modifiable)
 
App.Console.PrintMessage("object_Name    : "+str(object_Name)+"\n\n")
 
App.Console.PrintMessage("object_Name    : "+str(object_Name)+"\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# search the Sub Element Name of the sub object selected
 
try:
 
try:
 
     SubElement = FreeCADGui.Selection.getSelectionEx()                    # sub element name with getSelectionEx()
 
     SubElement = FreeCADGui.Selection.getSelectionEx()                    # sub element name with getSelectionEx()
Line 786: Line 837:
 
except:
 
except:
 
     App.Console.PrintMessage("Oups"+"\n\n")             
 
     App.Console.PrintMessage("Oups"+"\n\n")             
##################################################################################
 
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
App.Console.PrintMessage("sel            : "+str(sel[0])+"\n\n")          # sel[0] first object selected
 
##################################################################################
 
 
SubElement = FreeCADGui.Selection.getSelectionEx()                        # sub element name with getSelectionEx()
 
App.Console.PrintMessage("SubElement    : "+str(SubElement[0])+"\n\n")  # name of sub element
 
 
##################################################################################
 
##################################################################################
  
SubElement = Gui.Selection.getSelectionEx()[0].SubObjects[0].Length       # sub element or element name with getSelectionEx()
+
# give the length of the subObject selected
App.Console.PrintMessage("SubElement length: "+str(length)+"\n")         # length
+
SubElementLength = Gui.Selection.getSelectionEx()[0].SubObjects[0].Length # sub element or element name with getSelectionEx()
 +
App.Console.PrintMessage("SubElement length: "+str(SubElementLength)+"\n")# length
 
##################################################################################
 
##################################################################################
  
 +
# list the edges and the coordinates of the object[0] selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
i = 0
 
i = 0
Line 807: Line 852:
 
     a = sel[0].Shape.Edges[j[0]].Vertexes[0]
 
     a = sel[0].Shape.Edges[j[0]].Vertexes[0]
 
     App.Console.PrintMessage("X1            : "+str(a.Point.x)+"\n")    # coordinate XYZ first point
 
     App.Console.PrintMessage("X1            : "+str(a.Point.x)+"\n")    # coordinate XYZ first point
     App.Console.PrintMessage("Y1            : "+str(a.Point.y)+"\n")
+
     App.Console.PrintMessage("Y1            : "+str(a.Point.y)+"\n")     #
     App.Console.PrintMessage("Z1            : "+str(a.Point.z)+"\n")
+
     App.Console.PrintMessage("Z1            : "+str(a.Point.z)+"\n")     #
 
     try:
 
     try:
 
         a = sel[0].Shape.Edges[j[0]].Vertexes[1]
 
         a = sel[0].Shape.Edges[j[0]].Vertexes[1]
 
         App.Console.PrintMessage("X2            : "+str(a.Point.x)+"\n") # coordinate XYZ second point
 
         App.Console.PrintMessage("X2            : "+str(a.Point.x)+"\n") # coordinate XYZ second point
         App.Console.PrintMessage("Y2            : "+str(a.Point.y)+"\n")
+
         App.Console.PrintMessage("Y2            : "+str(a.Point.y)+"\n") #
         App.Console.PrintMessage("Z2            : "+str(a.Point.z)+"\n")
+
         App.Console.PrintMessage("Z2            : "+str(a.Point.z)+"\n") #
 
     except:
 
     except:
 
         App.Console.PrintMessage("Oups"+"\n")     
 
         App.Console.PrintMessage("Oups"+"\n")     
 
App.Console.PrintMessage("\n")     
 
App.Console.PrintMessage("\n")     
 
##################################################################################
 
##################################################################################
+
 
 +
# give the sub element name, length, coordinates, BoundBox, BoundBox.Center, Area of the SubObjects selected
 
try:
 
try:
 
     SubElement = FreeCADGui.Selection.getSelectionEx()                                        # sub element name with getSelectionEx()
 
     SubElement = FreeCADGui.Selection.getSelectionEx()                                        # sub element name with getSelectionEx()
Line 855: Line 901:
 
     App.Console.PrintMessage("Oups"+"\n\n")             
 
     App.Console.PrintMessage("Oups"+"\n\n")             
 
##################################################################################
 
##################################################################################
+
 
 +
# give the area of the object
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
surface = sel[0].Shape.Area                                              # Area object complete
 
surface = sel[0].Shape.Area                                              # Area object complete
 
App.Console.PrintMessage("surfaceObjet  : "+str(surface)+"\n\n")
 
App.Console.PrintMessage("surfaceObjet  : "+str(surface)+"\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# give the Center Of Mass and coordinates of the object
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
CenterOfMass = sel[0].Shape.CenterOfMass                                  # Center of Mass of the object
 
CenterOfMass = sel[0].Shape.CenterOfMass                                  # Center of Mass of the object
 
App.Console.PrintMessage("CenterOfMass  : "+str(CenterOfMass)+"\n")
 
App.Console.PrintMessage("CenterOfMass  : "+str(CenterOfMass)+"\n")
 
App.Console.PrintMessage("CenterOfMassX  : "+str(CenterOfMass[0])+"\n")  # coordinates [0]=X [1]=Y [2]=Z
 
App.Console.PrintMessage("CenterOfMassX  : "+str(CenterOfMass[0])+"\n")  # coordinates [0]=X [1]=Y [2]=Z
App.Console.PrintMessage("CenterOfMassY  : "+str(CenterOfMass[1])+"\n")
+
App.Console.PrintMessage("CenterOfMassY  : "+str(CenterOfMass[1])+"\n")   # or CenterOfMass.x, CenterOfMass.y, CenterOfMass.z
 
App.Console.PrintMessage("CenterOfMassZ  : "+str(CenterOfMass[2])+"\n\n")
 
App.Console.PrintMessage("CenterOfMassZ  : "+str(CenterOfMass[2])+"\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# list the all faces of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
for j in enumerate(sel[0].Shape.Faces):                                  # List alles faces of the object
 
for j in enumerate(sel[0].Shape.Faces):                                  # List alles faces of the object
Line 874: Line 923:
 
App.Console.PrintMessage("\n\n")
 
App.Console.PrintMessage("\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# give the volume of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
volume_ = sel[0].Shape.Volume                                            # Volume of the object
 
volume_ = sel[0].Shape.Volume                                            # Volume of the object
Line 880: Line 930:
 
##################################################################################
 
##################################################################################
 
   
 
   
 +
# give the BoundBox of the oject selected all type
 
objs = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
objs = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
+
if len(objs) >= 1:                                                         # serch the object type
if len(objs) >= 1:
 
 
     if hasattr(objs[0], "Shape"):
 
     if hasattr(objs[0], "Shape"):
 
         s = objs[0].Shape
 
         s = objs[0].Shape
Line 890: Line 940:
 
         s = objs[0].Points
 
         s = objs[0].Points
  
#sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
+
boundBox_= s.BoundBox                                                     # BoundBox of the object
#boundBox_= sel[0].Shape.BoundBox                                          # BoundBox of the object
+
App.Console.PrintMessage("boundBox_      : "+str(boundBox_)+"\n")         #
boundBox_= s.BoundBox                                                     # BoundBox of the object
 
App.Console.PrintMessage("boundBox_      : "+str(boundBox_)+"\n")
 
 
   
 
   
boundBoxLX = boundBox_.XLength                                           # Length x boundBox rectangle
+
boundBoxLX   = boundBox_.XLength                                         # Length x boundBox rectangle
boundBoxLY = boundBox_.YLength                                           # Length y boundBox rectangle
+
boundBoxLY   = boundBox_.YLength                                         # Length y boundBox rectangle
boundBoxLZ = boundBox_.ZLength                                           # Length z boundBox rectangle
+
boundBoxLZ   = boundBox_.ZLength                                         # Length z boundBox rectangle
 +
 
 +
boundBoxXMin = boundBox_.XMin                                            # coordonate XMin
 +
boundBoxYMin = boundBox_.YMin                                            # coordonate YMin
 +
boundBoxZMin = boundBox_.ZMin                                            # coordonate ZMin
 +
boundBoxXMax = boundBox_.XMax                                            # coordonate XMax
 +
boundBoxYMax = boundBox_.YMax                                            # coordonate YMax
 +
boundBoxZMax = boundBox_.ZMax                                            # coordonate ZMax
 +
 
 
boundBoxDiag= boundBox_.DiagonalLength                                    # Diagonal Length boundBox rectangle
 
boundBoxDiag= boundBox_.DiagonalLength                                    # Diagonal Length boundBox rectangle
 +
boundBoxCenter = boundBox_.Center                                        # BoundBox Center
  
 
App.Console.PrintMessage("boundBoxLX    : "+str(boundBoxLX)+"\n")
 
App.Console.PrintMessage("boundBoxLX    : "+str(boundBoxLX)+"\n")
 
App.Console.PrintMessage("boundBoxLY    : "+str(boundBoxLY)+"\n")
 
App.Console.PrintMessage("boundBoxLY    : "+str(boundBoxLY)+"\n")
App.Console.PrintMessage("boundBoxLZ    : "+str(boundBoxLZ)+"\n")
+
App.Console.PrintMessage("boundBoxLZ    : "+str(boundBoxLZ)+"\n\n")
App.Console.PrintMessage("boundBoxDiag  : "+str(boundBoxDiag)+"\n\n")
+
 
 +
App.Console.PrintMessage("boundBoxXMin  : "+str(boundBoxXMin)+"\n")
 +
App.Console.PrintMessage("boundBoxYMin  : "+str(boundBoxYMin)+"\n")
 +
App.Console.PrintMessage("boundBoxZMin  : "+str(boundBoxZMin)+"\n")
 +
App.Console.PrintMessage("boundBoxXMax  : "+str(boundBoxXMax)+"\n")
 +
App.Console.PrintMessage("boundBoxYMax  : "+str(boundBoxYMax)+"\n")
 +
App.Console.PrintMessage("boundBoxZMax  : "+str(boundBoxZMax)+"\n\n")
 +
 
 +
App.Console.PrintMessage("boundBoxDiag  : "+str(boundBoxDiag)+"\n")
 +
App.Console.PrintMessage("boundBoxCenter : "+str(boundBoxCenter)+"\n\n")
  
 
##################################################################################
 
##################################################################################
+
 
 +
# give the complete placement of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
pl = sel[0].Shape.Placement                                              # Placement Vector XYZ and Yaw-Pitch-Roll
 
pl = sel[0].Shape.Placement                                              # Placement Vector XYZ and Yaw-Pitch-Roll
 
App.Console.PrintMessage("Placement      : "+str(pl)+"\n")
 
App.Console.PrintMessage("Placement      : "+str(pl)+"\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# give the placement Base (xyz) of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
pl = sel[0].Shape.Placement.Base                                          # Placement Vector XYZ
 
pl = sel[0].Shape.Placement.Base                                          # Placement Vector XYZ
Line 917: Line 985:
 
##################################################################################
 
##################################################################################
 
   
 
   
 +
# give the placement Base (xyz) of the object selected
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
oripl_X = sel[0].Placement.Base[0]                                        # decode Placement X
 
oripl_X = sel[0].Placement.Base[0]                                        # decode Placement X
 
oripl_Y = sel[0].Placement.Base[1]                                        # decode Placement Y
 
oripl_Y = sel[0].Placement.Base[1]                                        # decode Placement Y
 
oripl_Z = sel[0].Placement.Base[2]                                        # decode Placement Z
 
oripl_Z = sel[0].Placement.Base[2]                                        # decode Placement Z
 +
 +
# same
 +
#oripl_X = sel[0].Placement.Base.x                                        # decode Placement X
 +
#oripl_Y = sel[0].Placement.Base.y                                        # decode Placement Y
 +
#oripl_Z = sel[0].Placement.Base.z                                        # decode Placement Z
 
   
 
   
 
App.Console.PrintMessage("oripl_X        : "+str(oripl_X)+"\n")
 
App.Console.PrintMessage("oripl_X        : "+str(oripl_X)+"\n")
Line 926: Line 1,000:
 
App.Console.PrintMessage("oripl_Z        : "+str(oripl_Z)+"\n\n")
 
App.Console.PrintMessage("oripl_Z        : "+str(oripl_Z)+"\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# give the placement rotation of the object selected (x, y, z, angle rotation)
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
rotation = sel[0].Placement.Rotation                                      # decode Placement Rotation
 
rotation = sel[0].Placement.Rotation                                      # decode Placement Rotation
 
App.Console.PrintMessage("rotation              : "+str(rotation)+"\n\n")
 
App.Console.PrintMessage("rotation              : "+str(rotation)+"\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# give the placement rotation of the object selected (x, y, z, angle rotation)
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
pl = sel[0].Shape.Placement.Rotation                                      # decode Placement Rotation other method
 
pl = sel[0].Shape.Placement.Rotation                                      # decode Placement Rotation other method
 
App.Console.PrintMessage("Placement Rot        : "+str(pl)+"\n\n")
 
App.Console.PrintMessage("Placement Rot        : "+str(pl)+"\n\n")
 
##################################################################################
 
##################################################################################
+
 
 +
# give the rotation of the object selected (angle rotation)
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
pl = sel[0].Shape.Placement.Rotation.Angle                                # decode Placement Rotation Angle
 
pl = sel[0].Shape.Placement.Rotation.Angle                                # decode Placement Rotation Angle
 
App.Console.PrintMessage("Placement Rot Angle  : "+str(pl)+"\n\n")
 
App.Console.PrintMessage("Placement Rot Angle  : "+str(pl)+"\n\n")
 
##################################################################################
 
##################################################################################
 +
 +
# give the rotation.Q of the object selected (angle rotation in Radian) for convert: math.degrees(angleInRadian)
 +
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 +
Rot  = sel[0].Placement.Rotation.Q                                      # Placement Rotation Q
 +
App.Console.PrintMessage("Rot          : "+str(Rot)+ "\n")
 
   
 
   
sel = FreeCADGui.Selection.getSelection()                                # select object with getSelection()
 
 
Rot_0 = sel[0].Placement.Rotation.Q[0]                                    # decode Placement Rotation Q
 
Rot_0 = sel[0].Placement.Rotation.Q[0]                                    # decode Placement Rotation Q
App.Console.PrintMessage("Rot_0        : "+str(Rot_0)+ " rad ,  "+str(180 * Rot_0 / 3.1416)+" deg "+"\n")
+
App.Console.PrintMessage("Rot_0        : "+str(Rot_0)+ " rad ,  "+str(180 * Rot_0 / 3.1416)+" deg "+"\n") # or math.degrees(angle)
 
   
 
   
 
Rot_1 = sel[0].Placement.Rotation.Q[1]                                    # decode Placement Rotation 1
 
Rot_1 = sel[0].Placement.Rotation.Q[1]                                    # decode Placement Rotation 1
App.Console.PrintMessage("Rot_1        : "+str(Rot_1)+ " rad ,  "+str(180 * Rot_1 / 3.1416)+" deg "+"\n")
+
App.Console.PrintMessage("Rot_1        : "+str(Rot_1)+ " rad ,  "+str(180 * Rot_1 / 3.1416)+" deg "+"\n") # or math.degrees(angle)
 
   
 
   
 
Rot_2 = sel[0].Placement.Rotation.Q[2]                                    # decode Placement Rotation 2
 
Rot_2 = sel[0].Placement.Rotation.Q[2]                                    # decode Placement Rotation 2
App.Console.PrintMessage("Rot_2        : "+str(Rot_2)+ " rad ,  "+str(180 * Rot_2 / 3.1416)+" deg "+"\n")
+
App.Console.PrintMessage("Rot_2        : "+str(Rot_2)+ " rad ,  "+str(180 * Rot_2 / 3.1416)+" deg "+"\n") # or math.degrees(angle)
+
 
 
Rot_3 = sel[0].Placement.Rotation.Q[3]                                    # decode Placement Rotation 3
 
Rot_3 = sel[0].Placement.Rotation.Q[3]                                    # decode Placement Rotation 3
 
App.Console.PrintMessage("Rot_3        : "+str(Rot_3)+"\n\n")
 
App.Console.PrintMessage("Rot_3        : "+str(Rot_3)+"\n\n")
 +
 +
Rot_Axis = sel[0].Placement.Rotation.Axis                                # Placement Rotation .Axis
 +
App.Console.PrintMessage("Rot_Axis      : "+str(Rot_Axis)+ "\n")
 +
 +
Rot_Angle = sel[0].Placement.Rotation.Angle                              # Placement Rotation .Angle
 +
App.Console.PrintMessage("Rot_Angle    : "+str(Rot_Angle)+ "\n\n")
 
##################################################################################
 
##################################################################################
+
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
+
# give the rotation of the object selected toEuler (angle rotation in degrees)
Yaw  = sel[0].Shape.Placement.Rotation.toEuler()[0]                     # decode angle Euler Yaw (Z)
+
sel = FreeCADGui.Selection.getSelection()                             # select object with getSelection()
 +
angle  = sel[0].Shape.Placement.Rotation.toEuler()                  # angle Euler
 +
App.Console.PrintMessage("Angle          : "+str(angle)+"\n")
 +
Yaw  = sel[0].Shape.Placement.Rotation.toEuler()[0]                 # decode angle Euler Yaw (Z) lacet (alpha)
 
App.Console.PrintMessage("Yaw            : "+str(Yaw)+"\n")
 
App.Console.PrintMessage("Yaw            : "+str(Yaw)+"\n")
Pitch = sel[0].Shape.Placement.Rotation.toEuler()[1]                     # decode angle Euler Pitch (Y)
+
Pitch = sel[0].Shape.Placement.Rotation.toEuler()[1]                 # decode angle Euler Pitch (Y) tangage (beta)
 
App.Console.PrintMessage("Pitch          : "+str(Pitch)+"\n")
 
App.Console.PrintMessage("Pitch          : "+str(Pitch)+"\n")
Roll  = sel[0].Shape.Placement.Rotation.toEuler()[2]                     # decode angle Euler Roll (X)
+
Roll  = sel[0].Shape.Placement.Rotation.toEuler()[2]                 # decode angle Euler Roll (X) roulis (gamma)
 
App.Console.PrintMessage("Roll          : "+str(Roll)+"\n\n")
 
App.Console.PrintMessage("Roll          : "+str(Roll)+"\n\n")
 
##################################################################################
 
##################################################################################
  
import DraftGeomUtils
+
# find Midpoint of the selected line
 +
import Draft, DraftGeomUtils
 
sel = FreeCADGui.Selection.getSelection()
 
sel = FreeCADGui.Selection.getSelection()
 
vecteur = DraftGeomUtils.findMidpoint(sel[0].Shape.Edges[0])              # find Midpoint
 
vecteur = DraftGeomUtils.findMidpoint(sel[0].Shape.Edges[0])              # find Midpoint
Line 972: Line 1,063:
 
##################################################################################
 
##################################################################################
 
}}
 
}}
 +
 
===Recherche d'un élément en donnant son Label===
 
===Recherche d'un élément en donnant son Label===
 +
 
{{Code|code=
 
{{Code|code=
# Extract the coordinate X,Y,Z and Angle giving the label  
+
# Extract the coordinate X,Y,Z and Angle giving the label (here "Cylindre")
 
App.Console.PrintMessage("Base.x      : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.x)+"\n")
 
App.Console.PrintMessage("Base.x      : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.x)+"\n")
 
App.Console.PrintMessage("Base.y      : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.y)+"\n")
 
App.Console.PrintMessage("Base.y      : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.y)+"\n")
Line 997: Line 1,090:
  
 
Changer la valeur "numberOfPoints" si vous voulez plus ou moins de précision
 
Changer la valeur "numberOfPoints" si vous voulez plus ou moins de précision
 +
 
{{Code|code=
 
{{Code|code=
 
numberOfPoints = 100                                                        # Decomposition number (or precision you can change)
 
numberOfPoints = 100                                                        # Decomposition number (or precision you can change)
Line 1,006: Line 1,100:
 
     print i, " X", p.x, " Y", p.y, " Z", p.z
 
     print i, " X", p.x, " Y", p.y, " Z", p.z
 
}}
 
}}
 +
 
Autre méthode d'affichage "Int" et "Float"
 
Autre méthode d'affichage "Int" et "Float"
 +
 
{{Code|code=
 
{{Code|code=
 
import Part
 
import Part
Line 1,062: Line 1,158:
  
 
}}
 
}}
 +
 
===Sélectionne tous les objets du document===
 
===Sélectionne tous les objets du document===
 +
 
{{Code|code=
 
{{Code|code=
 
import FreeCAD
 
import FreeCAD
Line 1,071: Line 1,169:
 
     Gui.Selection.addSelection(obj)              # select the object
 
     Gui.Selection.addSelection(obj)              # select the object
 
}}
 
}}
 +
 
===Sélectionner une face d'un objet===
 
===Sélectionner une face d'un objet===
 +
 
{{Code|code=
 
{{Code|code=
 
# select one face of the object
 
# select one face of the object
Line 1,084: Line 1,184:
 
#Draft.makeFacebinder(s)                      #  
 
#Draft.makeFacebinder(s)                      #  
 
}}
 
}}
 +
 
===Créer un objet dans la position de la camera===
 
===Créer un objet dans la position de la camera===
 +
 
{{Code|code=
 
{{Code|code=
 
# create one object of the position to camera with "getCameraOrientation()"
 
# create one object of the position to camera with "getCameraOrientation()"
Line 1,119: Line 1,221:
 
print rec.Name
 
print rec.Name
 
}}
 
}}
 +
 
Ici le même code simplifié
 
Ici le même code simplifié
 +
 
{{Code|code=
 
{{Code|code=
 
import Draft
 
import Draft
Line 1,131: Line 1,235:
  
 
Cet exemple montre comment trouver le vecteur normal() d'une face en cherchant les paramètres uv d'un point sur la surface et utiliser les paramètres u, v pour trouver le vecteur normal()
 
Cet exemple montre comment trouver le vecteur normal() d'une face en cherchant les paramètres uv d'un point sur la surface et utiliser les paramètres u, v pour trouver le vecteur normal()
 +
 
{{Code|code=
 
{{Code|code=
 
def normal(self):
 
def normal(self):
Line 1,148: Line 1,253:
 
       Part.show(line)
 
       Part.show(line)
 
}}
 
}}
 +
 
===Lire et écrire une Expression===
 
===Lire et écrire une Expression===
 +
 
{{Code|code=
 
{{Code|code=
 
import Draft
 
import Draft
Line 1,172: Line 1,279:
  
 
}}
 
}}
 
  
 
<div class="mw-translate-fuzzy">
 
<div class="mw-translate-fuzzy">
Line 1,197: Line 1,303:
 
}}
 
}}
  
 +
<div class="mw-translate-fuzzy">
 
{{docnav/fr|[[Embedding FreeCAD/fr|Incorporer FreeCAD]]|[[Line drawing function/fr|Fonction Line drawing]]}}
 
{{docnav/fr|[[Embedding FreeCAD/fr|Incorporer FreeCAD]]|[[Line drawing function/fr|Fonction Line drawing]]}}
 +
</div>
  
 
{{Userdocnavi/fr}}
 
{{Userdocnavi/fr}}

Revision as of 14:41, 22 November 2019

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe
Arrow-left.svg Page précédente: Embedding FreeCAD
Page suivante: Line drawing function Arrow-right.svg
Base ExampleCommandModel.png Tutoriel
Thème
Python
Niveau
Débutant
Temps d'exécution estimé
Auteur(s)
Version de FreeCAD
Fichier(s) exemple(s)

Contents


Cette page contient des exemples, des pièces, des extraits de code FreeCAD en Python, recueillis auprès d'utilisateurs expérimentés et de discussions sur les forums. Lisez les et utilisez les comme point de départ pour vos propres scripts...

Un fichier typique InitGui.py

En plus de votre module principal, chaque module doit contenir, un fichier InitGui.py, responsable de l'insertion du module dans l'interface principale.

Ceci est un simple exemple.

class ScriptWorkbench (Workbench): 
    MenuText = "Scripts"
    def Initialize(self):
        import Scripts # assuming Scripts.py is your module
        list = ["Script_Cmd"] # That list must contain command names, that can be defined in Scripts.py
        self.appendToolbar("My Scripts",list) 
        
Gui.addWorkbench(ScriptWorkbench())

Un fichier module typique

Ceci est l'exemple d'un fichier module principal, il contient tout ce que fait votre module. C'est le fichier Scripts.py invoqué dans l'exemple précédent. Vous avez ici toutes vos commandes personnalisées.

import FreeCAD, FreeCADGui 
 
class ScriptCmd: 
   def Activated(self): 
       # Here your write what your ScriptCmd does...
       FreeCAD.Console.PrintMessage('Hello, World!')
   def GetResources(self): 
       return {'Pixmap' : 'path_to_an_icon/myicon.png', 'MenuText': 'Short text', 'ToolTip': 'More detailed text'} 
       
FreeCADGui.addCommand('Script_Cmd', ScriptCmd())

Importer un nouveau type de fichier

Importer un nouveau type de fichier dans FreeCAD est facile. FreeCAD ne prends pas en considération l'importation de n'importe quelle données dans un document ouvert, parce que, vous ne pouvez pas ouvrir directement un nouveau type de fichier.

Donc, ce que vous devez faire, c'est ajouter la nouvelle extension de fichier à la liste des extensions connues de FreeCAD, et, d'écrire le code qui va lire le fichier et créer les objets FreeCAD que vous voulez.

Cette ligne doit être ajoutée au fichier InitGui.py pour ajouter la nouvelle extension de fichier à la liste:

# Assumes Import_Ext.py is the file that has the code for opening and reading .ext files
FreeCAD.addImportType("Your new File Type (*.ext)","Import_Ext")

Puis, dans le fichier Import_Ext.py, faites:

def open(filename): 
   doc=App.newDocument()
   # here you do all what is needed with filename, read, classify data, create corresponding FreeCAD objects
   doc.recompute()

Pour exporter votre document avec une nouvelle extension, le fonctionnement est le même, mais vous devrez faire:

FreeCAD.addExportType("Your new File Type (*.ext)","Export_Ext") 

Ajouter une ligne

Une ligne, à uniquement deux points.

import Part,PartGui 
doc=App.activeDocument() 
# add a line element to the document and set its points 
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Ajouter un polygone

Un polygone est simplement un ensemble de segments connnectés (un polyline dans AutoCAD) il n'est pas obligatoirement fermé.

import Part,PartGui 
doc=App.activeDocument()
n=list() 
# create a 3D vector, set its coordinates and add it to the list 
v=App.Vector(0,0,0) 
n.append(v) 
v=App.Vector(10,0,0) 
n.append(v) 
#... repeat for all nodes 
# Create a polygon object and set its nodes 
p=doc.addObject("Part::Polygon","Polygon") 
p.Nodes=n 
doc.recompute()

Ajout et suppression d'objet(s) dans un groupe

doc=App.activeDocument() 
grp=doc.addObject("App::DocumentObjectGroup", "Group") 
lin=doc.addObject("Part::Feature", "Line")
grp.addObject(lin) # adds the lin object to the group grp
grp.removeObject(lin) # removes the lin object from the group grp

PS: vous pouvez aussi ajouter un groupe dans un groupe . . .

Ajout d'une maille (Mesh)

import Mesh
doc=App.activeDocument()
# create a new empty mesh
m = Mesh.Mesh()
# build up box out of 12 facets
m.addFacet(0.0,0.0,0.0, 0.0,0.0,1.0, 0.0,1.0,1.0)
m.addFacet(0.0,0.0,0.0, 0.0,1.0,1.0, 0.0,1.0,0.0)
m.addFacet(0.0,0.0,0.0, 1.0,0.0,0.0, 1.0,0.0,1.0)
m.addFacet(0.0,0.0,0.0, 1.0,0.0,1.0, 0.0,0.0,1.0)
m.addFacet(0.0,0.0,0.0, 0.0,1.0,0.0, 1.0,1.0,0.0)
m.addFacet(0.0,0.0,0.0, 1.0,1.0,0.0, 1.0,0.0,0.0)
m.addFacet(0.0,1.0,0.0, 0.0,1.0,1.0, 1.0,1.0,1.0)
m.addFacet(0.0,1.0,0.0, 1.0,1.0,1.0, 1.0,1.0,0.0)
m.addFacet(0.0,1.0,1.0, 0.0,0.0,1.0, 1.0,0.0,1.0)
m.addFacet(0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,1.0)
m.addFacet(1.0,1.0,0.0, 1.0,1.0,1.0, 1.0,0.0,1.0)
m.addFacet(1.0,1.0,0.0, 1.0,0.0,1.0, 1.0,0.0,0.0)
# scale to a edge langth of 100
m.scale(100.0)
# add the mesh to the active document
me=doc.addObject("Mesh::Feature","Cube")
me.Mesh=m

Ajout d'un arc ou d'un cercle

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle") # create a document with a circle feature 
f.Shape = c.toShape() # Assign the circle shape to the shape property 
doc.recompute()

Accéder et changer la représentation d'un objet

Chaque objet dans un document FreeCAD a un objet vue associé a une représentation qui stocke tous les paramètres qui définissent les propriétés de l'objet, comme, la couleur, l'épaisseur de la ligne, etc ..

gad=Gui.activeDocument()   # access the active document containing all 
                          # view representations of the features in the
                          # corresponding App document 

v=gad.getObject("Cube")    # access the view representation to the Mesh feature 'Cube' 
v.ShapeColor               # prints the color to the console 
v.ShapeColor=(1.0,1.0,1.0) # sets the shape color to white

Observation des évènements de la souris dans la vue 3D via Python

Le cadre Inventor permet d'ajouter un ou plusieurs noeuds (nodes) de rappel à la scène graphique visualisée. Par défaut, FreeCAD, possède un noeud (node) de rappel installé par la visionneuse (fenêtre d'affichage des graphes), qui permet d'ajouter des fonctions statiques ou globales en C++. Des méthodes de liaisons appropriées sont fournies avec Python, pour permettre l'utilisation de cette technique à partir de codes Python.

App.newDocument()
v=Gui.activeDocument().activeView()
 
#This class logs any mouse button events. As the registered callback function fires twice for 'down' and
#'up' events we need a boolean flag to handle this.
class ViewObserver:
   def logPosition(self, info):
       down = (info["State"] == "DOWN")
       pos = info["Position"]
       if (down):
           FreeCAD.Console.PrintMessage("Clicked on position: ("+str(pos[0])+", "+str(pos[1])+")\n")
       
o = ViewObserver()
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)

Maintenant, choisissez une zone dans l'écran (surface de travail) 3D et observez les messages affichés dans la fenêtre de sortie. Pour terminer l'observation il suffit de faire:

v.removeEventCallback("SoMouseButtonEvent",c)

Les types d’évènements suivants sont pris en charge:

  • SoEvent -- tous types d'évènements
  • SoButtonEvent -- tous les évènements, boutons, molette
  • SoLocation2Event -- tous les évènements 2D (déplacements normaux de la souris)
  • SoMotion3Event -- tous les évènements 3D (pour le spaceball)
  • SoKeyboardEvent -- évènements des touches flèche haut et flèche bas
  • SoMouseButtonEvent -- tous les évènements boutons Haut et Bas de la souris
  • SoSpaceballButtonEvent -- tous les évènements Haut et Bas (pour le spaceball)

Les fonctions Python qui peuvent être enregistrées avec addEventCallback() attendent la définition d'une bibliothèque.

Suivant la façon dont l’évènement survient, la bibliothèque peut disposer de différentes clefs.

Il y a une clef pour chaque événement:

  • Type -- le nom du type d'évènement par exemple SoMouseEvent, SoLocation2Event, ...
  • Time -- l'heure courante codée dans une chaîne string
  • Position -- un tuple de deux integers, donant la position x,y de la souris
  • ShiftDown -- type boolean, true si Shift est pressé sinon, false
  • CtrlDown -- type boolean, true si Ctrl est pressé sinon, false
  • AltDown -- type boolean, true si Alt est pressé sinon, false

Pour un évènement bouton comme clavier, souris ou spaceball

  • State -- la chaîne UP si le bouton est relevé, DOWN si le bouton est enfoncé ou UNKNOWN si rien ne se passe

Pour un évènement clavier:

  • Key -- le caractère de la touche qui est pressée

Pour un évènement bouton de souris:

  • Button -- le bouton pressé peut être BUTTON1, ..., BUTTON5 ou tous

Pour un évènement spaceball:

  • Button -- le bouton pressé peut être BUTTON1, ..., BUTTON7 ou tous

Et finalement les évènement de mouvements:

  • Translation -- un tuple de trois float()
  • Rotation -- un quaternion, tuple de quattre float()

Afficher les évènements claviers et commandes

Cette macro affiche dans la vue du rapport les touches enfoncées et tous les événements commande

App.newDocument()
v=Gui.activeDocument().activeView()
class ViewObserver:
   def logPosition(self, info):
       try:
           down = (info["Key"])
           FreeCAD.Console.PrintMessage(str(down)+"\n") # here the character pressed
           FreeCAD.Console.PrintMessage(str(info)+"\n") # list all events command
           FreeCAD.Console.PrintMessage("_______________________________________"+"\n")
       except Exception:
           None
 
o = ViewObserver()
c = v.addEventCallback("SoEvent",o.logPosition)

#v.removeEventCallback("SoEvent",c) # remove ViewObserver

Manipulation de scènes graphiques en Python

Il est aussi possible d'afficher ou de changer de scène en programmation Python, avec le module pivy en combinaison avec Coin

from pivy.coin import *                # load the pivy module
view = Gui.ActiveDocument.ActiveView   # get the active viewer
root = view.getSceneGraph()            # the root is an SoSeparator node
root.addChild(SoCube())
view.fitAll()

L'API Python de pivy est créé en utilisant l'outil SWIG. Comme dans FreeCAD nous utilisons certains noeuds (nodes) écrits automatiquement nous ne pouvons pas les créer directement en Python. Il est cependant, possible de créer un noeud avec son nom interne. Un exemple de SoFCSelection, le type peut être créé avec:

type = SoType.fromName("SoFCSelection")
node = type.createInstance()

Ajouter et effacer des objets de la scène

Ajouter de nouveaux noeuds dans la scène graphique peut être fait de cette façon. Prenez toujours soin d'ajouter un SoSeparator pour, contenir les propriétés de la forme géométrique, les coordonnées et le matériel d'un même objet. L'exemple suivant ajoute une ligne rouge à partir de (0,0,0) à (10,0,0):

from pivy import coin
sg = Gui.ActiveDocument.ActiveView.getSceneGraph()
co = coin.SoCoordinate3()
pts = [[0,0,0],[10,0,0]]
co.point.setValues(0,len(pts),pts)
ma = coin.SoBaseColor()
ma.rgb = (1,0,0)
li = coin.SoLineSet()
li.numVertices.setValue(2)
no = coin.SoSeparator()
no.addChild(co)
no.addChild(ma)
no.addChild(li)
sg.addChild(no)

Pour le supprimer, il suffit de:

sg.removeChild(no)

Enregistre la vue 3Den pratiquant une rotation dans une série de 36 fichiers dans les axes X Y Z

import math
import time
from FreeCAD import Base
from pivy import coin

size=(1000,1000)
dirname = "C:/Temp/animation/"
steps=36
angle=2*math.pi/steps

matX=Base.Matrix()
matX.rotateX(angle)
stepsX=Base.Placement(matX).Rotation

matY=Base.Matrix()
matY.rotateY(angle)
stepsY=Base.Placement(matY).Rotation

matZ=Base.Matrix()
matZ.rotateZ(angle)
stepsZ=Base.Placement(matZ).Rotation

view=Gui.ActiveDocument.ActiveView
cam=view.getCameraNode()
rotCamera=Base.Rotation(*cam.orientation.getValue().getValue())

# this sets the lookat point to the center of circumsphere of the global bounding box
view.fitAll()

# the camera's position, i.e. the user's eye point
position=Base.Vector(*cam.position.getValue().getValue())
distance=cam.focalDistance.getValue()

# view direction
vec=rotCamera.multVec(Base.Vector(0,0,-1))

# this is the point on the screen the camera looks at
# when rotating the camera we should make this point fix
lookat=position+vec*distance

# around x axis
for i in range(steps):
    rotCamera=stepsX.multiply(rotCamera)
    cam.orientation.setValue(*rotCamera.Q)
    vec=rotCamera.multVec(Base.Vector(0,0,-1))
    pos=lookat-vec*distance
    cam.position.setValue(pos.x,pos.y,pos.z)
    Gui.updateGui()
    time.sleep(0.3)
    view.saveImage(dirname+"x-%d.png" % i,*size)

# around y axis
for i in range(steps):
    rotCamera=stepsY.multiply(rotCamera)
    cam.orientation.setValue(*rotCamera.Q)
    vec=rotCamera.multVec(Base.Vector(0,0,-1))
    pos=lookat-vec*distance
    cam.position.setValue(pos.x,pos.y,pos.z)
    Gui.updateGui()
    time.sleep(0.3)
    view.saveImage(dirname+"y-%d.png" % i,*size)

# around z axis
for i in range(steps):
    rotCamera=stepsZ.multiply(rotCamera)
    cam.orientation.setValue(*rotCamera.Q)
    vec=rotCamera.multVec(Base.Vector(0,0,-1))
    pos=lookat-vec*distance
    cam.position.setValue(pos.x,pos.y,pos.z)
    Gui.updateGui()
    time.sleep(0.3)
    view.saveImage(dirname+"z-%d.png" % i,*size)

Ajout de widgets personnalisés à l'interface

Vous pouvez créer un widget avec Qt designer, le transformer en Script Python et l'incorporer dans l'interface de FreeCAD avec PySide.

Le code python produit par le compilateur python Ui (l'outil qui convertit les fichiers .ui de qt-designer en code python) généralement codé comme ceci (il est simple, vous pouvez aussi le coder directement en Python):

class myWidget_Ui(object):
    def setupUi(self, myWidget):
        myWidget.setObjectName("my Nice New Widget")
        myWidget.resize(QtCore.QSize(QtCore.QRect(0,0,300,100).size()).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget
 
        self.label = QtGui.QLabel(myWidget) # creates a label
        self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
        self.label.setObjectName("label") # sets its name, so it can be found by name

    def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
        myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
        self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))

Puis, vous devez créer une référence à la fenêtre FreeCAD Qt, lui insérer le widget personnalisé, et transférer le code Ui du widget que nous venons de faire dans le vôtre avec:

app = QtGui.qApp
FCmw = app.activeWindow() # the active qt window, = the freecad window since we are inside it
# FCmw = FreeCADGui.getMainWindow() # use this line if the 'addDockWidget' error is declared
myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window

Ajout d'une liste déroulante

Le code suivant vous permet d'ajouter une liste déroulante dans FreeCAD, en plus des onglets "Projet" et "tâches". Il utilise également le module uic pour charger un fichier ui directement dans cet onglet.

# create new Tab in ComboView
from PySide import QtGui,QtCore
#from PySide import uic

def getMainWindow():
   "returns the main window"
   # using QtGui.qApp.activeWindow() isn't very reliable because if another
   # widget than the mainwindow is active (e.g. a dialog) the wrong widget is
   # returned
   toplevel = QtGui.qApp.topLevelWidgets()
   for i in toplevel:
       if i.metaObject().className() == "Gui::MainWindow":
           return i
   raise Exception("No main window found")

def getComboView(mw):
   dw=mw.findChildren(QtGui.QDockWidget)
   for i in dw:
       if str(i.objectName()) == "Combo View":
           return i.findChild(QtGui.QTabWidget)
       elif str(i.objectName()) == "Python Console":
           return i.findChild(QtGui.QTabWidget)
   raise Exception ("No tab widget found")

mw = getMainWindow()
tab = getComboView(getMainWindow())
tab2=QtGui.QDialog()
tab.addTab(tab2,"A Special Tab")

#uic.loadUi("/myTaskPanelforTabs.ui",tab2)
tab2.show()
#tab.removeTab(2)

Activer ou désactiver une fenêtre

from PySide import QtGui
mw=FreeCADGui.getMainWindow()
dws=mw.findChildren(QtGui.QDockWidget)

# objectName may be :
# "Report view"
# "Tree view"
# "Property view"
# "Selection view"
# "Combo View"
# "Python console"
# "draftToolbar"

for i in dws:
  if i.objectName() == "Report view":
    dw=i
    break

va=dw.toggleViewAction()
va.setChecked(True)        # True or False
dw.setVisible(True)        # True or False

Ouverture d'une page web

import WebGui
WebGui.openBrowser("http://www.example.com")

Obtenir le code HTML d'une page Web ouverte

from PySide import QtGui,QtWebKit
a = QtGui.qApp
mw = a.activeWindow()
v = mw.findChild(QtWebKit.QWebFrame)
html = unicode(v.toHtml())
print html

Extraire et utiliser les coordonnées de 3 points sélectionnés

# -*- coding: utf-8 -*-
# the line above to put the accentuated in the remarks
# If this line is missing, an error will be returned
# extract and use the coordinates of 3 objects selected
import Part, FreeCAD, math, PartGui, FreeCADGui
from FreeCAD import Base, Console
sel = FreeCADGui.Selection.getSelection() # " sel " contains the items selected
if len(sel)!=3 :
  # If there are no 3 objects selected, an error is displayed in the report view
  # The \r and \n at the end of line mean return and the newline CR + LF.
  Console.PrintError("Select 3 points exactly\r\n")
else :
  points=[]
  for obj in sel:
    points.append(obj.Shape.BoundBox.Center)

  for pt in points:
    # display of the coordinates in the report view
    Console.PrintMessage(str(pt.x)+"\r\n")
    Console.PrintMessage(str(pt.y)+"\r\n")
    Console.PrintMessage(str(pt.z)+"\r\n")

  Console.PrintMessage(str(pt[1]) + "\r\n")

Lister les objets

# -*- coding: utf-8 -*-
import FreeCAD,Draft
# List all objects of the document
doc = FreeCAD.ActiveDocument
objs = FreeCAD.ActiveDocument.Objects
#App.Console.PrintMessage(str(objs) + "\n")
#App.Console.PrintMessage(str(len(FreeCAD.ActiveDocument.Objects)) + " Objects"  + "\n")

for obj in objs:
    a = obj.Name                                             # list the Name  of the object  (not modifiable)
    b = obj.Label                                            # list the Label of the object  (modifiable)
    try:
        c = obj.LabelText                                    # list the LabeText of the text (modifiable)
        App.Console.PrintMessage(str(a) +" "+ str(b) +" "+ str(c) + "\n") # Displays the Name the Label and the text
    except:
        App.Console.PrintMessage(str(a) +" "+ str(b) + "\n") # Displays the Name and the Label of the object

#doc.removeObject("Box") # Clears the designated object

Lister les dimensions en donnant le nom de l'objet

for edge in FreeCAD.ActiveDocument.MyObjectName.Shape.Edges: # replace "MyObjectName" for list
    print edge.Length

Fonction résidente avec action au clic de souris

Here with SelObserver on a object select

# -*- coding: utf-8 -*-
# causes an action to the mouse click on an object
# This function remains resident (in memory) with the function "addObserver(s)"
# "removeObserver(s) # Uninstalls the resident function
class SelObserver:
    def setPreselection(self,doc,obj,sub):                # Preselection object
        App.Console.PrintMessage(str(sub)+ "\n")          # The part of the object name

    def addSelection(self,doc,obj,sub,pnt):               # Selection object
        App.Console.PrintMessage("addSelection"+ "\n")
        App.Console.PrintMessage(str(doc)+ "\n")          # Name of the document
        App.Console.PrintMessage(str(obj)+ "\n")          # Name of the object
        App.Console.PrintMessage(str(sub)+ "\n")          # The part of the object name
        App.Console.PrintMessage(str(pnt)+ "\n")          # Coordinates of the object
        App.Console.PrintMessage("______"+ "\n")

    def removeSelection(self,doc,obj,sub):                # Delete the selected object
        App.Console.PrintMessage("removeSelection"+ "\n")

    def setSelection(self,doc):                           # Selection in ComboView
        App.Console.PrintMessage("setSelection"+ "\n")

    def clearSelection(self,doc):                         # If click on the screen, clear the selection
        App.Console.PrintMessage("clearSelection"+ "\n")  # If click on another object, clear the previous object
s =SelObserver()
FreeCADGui.Selection.addObserver(s)                       # install the function mode resident
#FreeCADGui.Selection.removeObserver(s)                   # Uninstall the resident function

Other example with ViewObserver on a object select or view

App.newDocument()
v=Gui.activeDocument().activeView()
 
#This class logs any mouse button events. As the registered callback function fires twice for 'down' and
#'up' events we need a boolean flag to handle this.
class ViewObserver:
   def __init__(self, view):
       self.view = view
   
   def logPosition(self, info):
       down = (info["State"] == "DOWN")
       pos = info["Position"]
       if (down):
           FreeCAD.Console.PrintMessage("Clicked on position: ("+str(pos[0])+", "+str(pos[1])+")\n")
           pnt = self.view.getPoint(pos)
           FreeCAD.Console.PrintMessage("World coordinates: " + str(pnt) + "\n")
           info = self.view.getObjectInfo(pos)
           FreeCAD.Console.PrintMessage("Object info: " + str(info) + "\n")

o = ViewObserver(v)
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)

Recherche et sélection de tous les éléments sous le curseur

from pivy import coin
import FreeCADGui

def mouse_over_cb( event_callback):
    event = event_callback.getEvent()
    pos = event.getPosition().getValue()
    listObjects = FreeCADGui.ActiveDocument.ActiveView.getObjectsInfo((int(pos[0]),int(pos[1])))
    obj = []
    if listObjects:
        FreeCAD.Console.PrintMessage("\n *** Objects under mouse pointer ***")
        for o in listObjects:
            label = str(o["Object"])
            if not label in obj:
                obj.append(label)
        FreeCAD.Console.PrintMessage("\n"+str(obj))


view = FreeCADGui.ActiveDocument.ActiveView

mouse_over = view.addEventCallbackPivy( coin.SoLocation2Event.getClassTypeId(), mouse_over_cb )

# to remove Callback :
#view.removeEventCallbackPivy( coin.SoLocation2Event.getClassTypeId(), mouse_over)

####
#The easy way is probably to use FreeCAD's selection.
#FreeCADGui.ActiveDocument.ActiveView.getObjectsInfo(mouse_coords)

####
#you get that kind of result :
#'Document': 'Unnamed', 'Object': 'Box', 'Component': 'Face2', 'y': 8.604081153869629, 'x': 21.0, 'z': 8.553047180175781

####
#You can use this data to add your element to FreeCAD's selection :
#FreeCADGui.Selection.addSelection(FreeCAD.ActiveDocument.Box,'Face2',21.0,8.604081153869629,8.553047180175781)

Lister les composantes d'un objet

# -*- coding: utf-8 -*-
# This function list the components of an object
# and extract this object its XYZ coordinates,
# its edges and their lengths center of mass and coordinates
# its faces and their center of mass
# its faces and their surfaces and coordinates
# 8/05/2014

import Draft,Part
def detail():
    sel = FreeCADGui.Selection.getSelection()   # Select an object
    if len(sel) != 0:                           # If there is a selection then
        Vertx=[]
        Edges=[]
        Faces=[]
        compt_V=0
        compt_E=0
        compt_F=0
        pas    =0
        perimetre = 0.0   
        EdgesLong = []

        # Displays the "Name" and the "Label" of the selection
        App.Console.PrintMessage("Selection > " + str(sel[0].Name) + "  " + str(sel[0].Label) +"\n"+"\n")

        for j in enumerate(sel[0].Shape.Edges):                                     # Search the "Edges" and their lengths
            compt_E+=1
            Edges.append("Edge%d" % (j[0]+1))
            EdgesLong.append(str(sel[0].Shape.Edges[compt_E-1].Length))
            perimetre += (sel[0].Shape.Edges[compt_E-1].Length)                     # calculates the perimeter

            # Displays the "Edge" and its length
            App.Console.PrintMessage("Edge"+str(compt_E)+" Length > "+str(sel[0].Shape.Edges[compt_E-1].Length)+"\n")

            # Displays the "Edge" and its center mass
            App.Console.PrintMessage("Edge"+str(compt_E)+" Center > "+str(sel[0].Shape.Edges[compt_E-1].CenterOfMass)+"\n")

            num = sel[0].Shape.Edges[compt_E-1].Vertexes[0]
            Vertx.append("X1: "+str(num.Point.x))
            Vertx.append("Y1: "+str(num.Point.y))
            Vertx.append("Z1: "+str(num.Point.z))
            # Displays the coordinates 1
            App.Console.PrintMessage("X1: "+str(num.Point[0])+" Y1: "+str(num.Point[1])+" Z1: "+str(num.Point[2])+"\n")

            try:
                num = sel[0].Shape.Edges[compt_E-1].Vertexes[1]
                Vertx.append("X2: "+str(num.Point.x))
                Vertx.append("Y2: "+str(num.Point.y))
                Vertx.append("Z2: "+str(num.Point.z))
            except:
                Vertx.append("-")
                Vertx.append("-")
                Vertx.append("-")
            # Displays the coordinates 2
            App.Console.PrintMessage("X2: "+str(num.Point[0])+" Y2: "+str(num.Point[1])+" Z2: "+str(num.Point[2])+"\n")

            App.Console.PrintMessage("\n")
        App.Console.PrintMessage("Perimeter of the form  : "+str(perimetre)+"\n") 

        App.Console.PrintMessage("\n")
        FacesSurf = []
        for j in enumerate(sel[0].Shape.Faces):                                      # Search the "Faces" and their surface
            compt_F+=1
            Faces.append("Face%d" % (j[0]+1))
            FacesSurf.append(str(sel[0].Shape.Faces[compt_F-1].Area))

            # Displays 'Face' and its surface
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Surface "+str(sel[0].Shape.Faces[compt_F-1].Area)+"\n")

            # Displays 'Face' and its CenterOfMass
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Center  "+str(sel[0].Shape.Faces[compt_F-1].CenterOfMass)+"\n")

            # Displays 'Face' and its Coordinates
            FacesCoor = []
            fco = 0
            for f0 in sel[0].Shape.Faces[compt_F-1].Vertexes:                        # Search the Vertexes of the face
                fco += 1
                FacesCoor.append("X"+str(fco)+": "+str(f0.Point.x))
                FacesCoor.append("Y"+str(fco)+": "+str(f0.Point.y))
                FacesCoor.append("Z"+str(fco)+": "+str(f0.Point.z))

            # Displays 'Face' and its Coordinates
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Coordinate"+str(FacesCoor)+"\n")

            # Displays 'Face' and its Volume
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Volume  "+str(sel[0].Shape.Faces[compt_F-1].Volume)+"\n")
            App.Console.PrintMessage("\n")

        # Displays the total surface of the form
        App.Console.PrintMessage("Surface of the form    : "+str(sel[0].Shape.Area)+"\n")

        # Displays the total Volume of the form
        App.Console.PrintMessage("Volume  of the form    : "+str(sel[0].Shape.Volume)+"\n")

detail()

Lister les PropertiesList

import FreeCADGui
from FreeCAD import Console
o = App.ActiveDocument.ActiveObject
op = o.PropertiesList
for p in op:
    Console.PrintMessage("Property: "+ str(p)+ " Value: " + str(o.getPropertyByName(p))+"\r\n")

Ajouter une Propriété "Commentaire"

import Draft
obj = FreeCADGui.Selection.getSelection()[0]
obj.addProperty("App::PropertyString","GComment","Draft","Font name").GComment = "Comment here"
App.activeDocument().recompute()

Recherche et extraction de données

Exemple de recherche et décodage des informations d'un objet

Chaque section est séparée par des dièses "############" vous pouvez les copier directement dans la console, les utiliser dans vos macro ou utiliser la macro complète. La description de la commande est dans le commentaire.

L'affichage se fait dans la vue rapport (Menu Affichage → Vues → Vue rapport)

# -*- coding: utf-8 -*-
from __future__ import unicode_literals
 
# Exemples de recherche et de decodage d'informations sur un objet
# Chaque section peut etre copiee directement dans la console Python ou dans une macro ou utilisez la macro tel quel
# Certaines commandes se repetent seul l'approche est differente
# L'affichage se fait dans la Vue rapport : Menu Affichage > Vues > Vue rapport
#
# Examples of research and decoding information on an object
# Each section can be copied directly into the Python console, or in a macro or uses this macro
# Certain commands as repeat alone approach is different
# Displayed on Report view : Menu View > Views > report view
#
# rev:30/08/2014:29/09/2014:17/09/2015 22/11/2019
 
from FreeCAD import Base
import DraftVecUtils, Draft, Part

# search the name of the active document 
mydoc = FreeCAD.activeDocument().Name                                     # Name of active Document
App.Console.PrintMessage("Active docu    : "+(mydoc)+"\n")
##################################################################################

# search the label of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
object_Label = sel[0].Label                                               # Label of the object (modifiable)
App.Console.PrintMessage("object_Label   : "+(object_Label)+"\n")
##################################################################################

#TypeID object FreeCAD selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
App.Console.PrintMessage("sel            : "+str(sel[0])+"\n\n")          # sel[0] first object selected
##################################################################################

# search the Name of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
object_Name  = sel[0].Name                                                # Name of the object (not modifiable)
App.Console.PrintMessage("object_Name    : "+str(object_Name)+"\n\n")
##################################################################################

# search the Sub Element Name of the sub object selected
try:
    SubElement = FreeCADGui.Selection.getSelectionEx()                    # sub element name with getSelectionEx()
    element_ = SubElement[0].SubElementNames[0]                           # name of 1 element selected
    App.Console.PrintMessage("elementSelec   : "+str(element_)+"\n\n")            
except:
    App.Console.PrintMessage("Oups"+"\n\n")            
##################################################################################

# give the length of the subObject selected
SubElementLength = Gui.Selection.getSelectionEx()[0].SubObjects[0].Length # sub element or element name with getSelectionEx()
App.Console.PrintMessage("SubElement length: "+str(SubElementLength)+"\n")# length
##################################################################################

# list the edges and the coordinates of the object[0] selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
i = 0
for j in enumerate(sel[0].Shape.Edges):                                   # list all Edges
    i += 1
    App.Console.PrintMessage("Edges n : "+str(i)+"\n")
    a = sel[0].Shape.Edges[j[0]].Vertexes[0]
    App.Console.PrintMessage("X1             : "+str(a.Point.x)+"\n")     # coordinate XYZ first point
    App.Console.PrintMessage("Y1             : "+str(a.Point.y)+"\n")     #
    App.Console.PrintMessage("Z1             : "+str(a.Point.z)+"\n")     #
    try:
        a = sel[0].Shape.Edges[j[0]].Vertexes[1]
        App.Console.PrintMessage("X2             : "+str(a.Point.x)+"\n") # coordinate XYZ second point
        App.Console.PrintMessage("Y2             : "+str(a.Point.y)+"\n") #
        App.Console.PrintMessage("Z2             : "+str(a.Point.z)+"\n") #
    except:
        App.Console.PrintMessage("Oups"+"\n")    
App.Console.PrintMessage("\n")    
##################################################################################

# give the sub element name, length, coordinates, BoundBox, BoundBox.Center, Area of the SubObjects selected
try:
    SubElement = FreeCADGui.Selection.getSelectionEx()                                        # sub element name with getSelectionEx()
    subElementName = Gui.Selection.getSelectionEx()[0].SubElementNames[0]                     # sub element name with getSelectionEx()
    App.Console.PrintMessage("subElementName : "+str(subElementName)+"\n")
    
    subObjectLength = Gui.Selection.getSelectionEx()[0].SubObjects[0].Length                  # sub element Length
    App.Console.PrintMessage("subObjectLength: "+str(subObjectLength)+"\n\n")
    
    subObjectX1 = Gui.Selection.getSelectionEx()[0].SubObjects[0].Vertexes[0].Point.x         # sub element coordinate X1
    App.Console.PrintMessage("subObject_X1   : "+str(subObjectX1)+"\n")
    subObjectY1 = Gui.Selection.getSelectionEx()[0].SubObjects[0].Vertexes[0].Point.y         # sub element coordinate Y1
    App.Console.PrintMessage("subObject_Y1   : "+str(subObjectY1)+"\n")
    subObjectZ1 = Gui.Selection.getSelectionEx()[0].SubObjects[0].Vertexes[0].Point.z         # sub element coordinate Z1
    App.Console.PrintMessage("subObject_Z1   : "+str(subObjectZ1)+"\n\n")

    try:
        subObjectX2 = Gui.Selection.getSelectionEx()[0].SubObjects[0].Vertexes[1].Point.x     # sub element coordinate X2
        App.Console.PrintMessage("subObject_X2   : "+str(subObjectX2)+"\n")
        subObjectY2 = Gui.Selection.getSelectionEx()[0].SubObjects[0].Vertexes[1].Point.y     # sub element coordinate Y2
        App.Console.PrintMessage("subObject_Y2   : "+str(subObjectY2)+"\n")
        subObjectZ2 = Gui.Selection.getSelectionEx()[0].SubObjects[0].Vertexes[1].Point.z     # sub element coordinate Z2
        App.Console.PrintMessage("subObject_Z2   : "+str(subObjectZ2)+"\n\n")
    except:
        App.Console.PrintMessage("Oups"+"\n\n")            

    subObjectBoundBox = Gui.Selection.getSelectionEx()[0].SubObjects[0].BoundBox              # sub element BoundBox coordinates
    App.Console.PrintMessage("subObjectBBox  : "+str(subObjectBoundBox)+"\n")
    
    subObjectBoundBoxCenter = Gui.Selection.getSelectionEx()[0].SubObjects[0].BoundBox.Center # sub element BoundBoxCenter
    App.Console.PrintMessage("subObjectBBoxCe: "+str(subObjectBoundBoxCenter)+"\n")
    
    surfaceFace = Gui.Selection.getSelectionEx()[0].SubObjects[0].Area                        # Area of the face selected
    App.Console.PrintMessage("surfaceFace    : "+str(surfaceFace)+"\n\n")
except:
    App.Console.PrintMessage("Oups"+"\n\n")            
##################################################################################

# give the area of the object
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
surface = sel[0].Shape.Area                                               # Area object complete
App.Console.PrintMessage("surfaceObjet   : "+str(surface)+"\n\n")
##################################################################################

# give the Center Of Mass and coordinates of the object
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
CenterOfMass = sel[0].Shape.CenterOfMass                                  # Center of Mass of the object
App.Console.PrintMessage("CenterOfMass   : "+str(CenterOfMass)+"\n")
App.Console.PrintMessage("CenterOfMassX  : "+str(CenterOfMass[0])+"\n")   # coordinates [0]=X [1]=Y [2]=Z
App.Console.PrintMessage("CenterOfMassY  : "+str(CenterOfMass[1])+"\n")   # or CenterOfMass.x, CenterOfMass.y, CenterOfMass.z
App.Console.PrintMessage("CenterOfMassZ  : "+str(CenterOfMass[2])+"\n\n")
##################################################################################

# list the all faces of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
for j in enumerate(sel[0].Shape.Faces):                                   # List alles faces of the object
    App.Console.PrintMessage("Face           : "+str("Face%d" % (j[0]+1))+"\n")
App.Console.PrintMessage("\n\n")
##################################################################################

# give the volume of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
volume_ = sel[0].Shape.Volume                                             # Volume of the object
App.Console.PrintMessage("volume_        : "+str(volume_)+"\n\n")
##################################################################################
 
# give the BoundBox of the oject selected all type
objs = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
if len(objs) >= 1:                                                         # serch the object type
    if hasattr(objs[0], "Shape"):
        s = objs[0].Shape
    elif hasattr(objs[0], "Mesh"):      # upgrade with wmayer thanks #http://forum.freecadweb.org/viewtopic.php?f=13&t=22331
        s = objs[0].Mesh
    elif hasattr(objs[0], "Points"):
        s = objs[0].Points

boundBox_= s.BoundBox                                                     # BoundBox of the object
App.Console.PrintMessage("boundBox_      : "+str(boundBox_)+"\n")         # 
 
boundBoxLX   = boundBox_.XLength                                          # Length x boundBox rectangle
boundBoxLY   = boundBox_.YLength                                          # Length y boundBox rectangle
boundBoxLZ   = boundBox_.ZLength                                          # Length z boundBox rectangle

boundBoxXMin = boundBox_.XMin                                             # coordonate XMin
boundBoxYMin = boundBox_.YMin                                             # coordonate YMin
boundBoxZMin = boundBox_.ZMin                                             # coordonate ZMin
boundBoxXMax = boundBox_.XMax                                             # coordonate XMax
boundBoxYMax = boundBox_.YMax                                             # coordonate YMax
boundBoxZMax = boundBox_.ZMax                                             # coordonate ZMax

boundBoxDiag= boundBox_.DiagonalLength                                    # Diagonal Length boundBox rectangle
boundBoxCenter = boundBox_.Center                                         # BoundBox Center

App.Console.PrintMessage("boundBoxLX     : "+str(boundBoxLX)+"\n")
App.Console.PrintMessage("boundBoxLY     : "+str(boundBoxLY)+"\n")
App.Console.PrintMessage("boundBoxLZ     : "+str(boundBoxLZ)+"\n\n")

App.Console.PrintMessage("boundBoxXMin   : "+str(boundBoxXMin)+"\n")
App.Console.PrintMessage("boundBoxYMin   : "+str(boundBoxYMin)+"\n")
App.Console.PrintMessage("boundBoxZMin   : "+str(boundBoxZMin)+"\n")
App.Console.PrintMessage("boundBoxXMax   : "+str(boundBoxXMax)+"\n")
App.Console.PrintMessage("boundBoxYMax   : "+str(boundBoxYMax)+"\n")
App.Console.PrintMessage("boundBoxZMax   : "+str(boundBoxZMax)+"\n\n")

App.Console.PrintMessage("boundBoxDiag   : "+str(boundBoxDiag)+"\n")
App.Console.PrintMessage("boundBoxCenter : "+str(boundBoxCenter)+"\n\n")

##################################################################################

# give the complete placement of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement                                               # Placement Vector XYZ and Yaw-Pitch-Roll
App.Console.PrintMessage("Placement      : "+str(pl)+"\n")
##################################################################################

# give the placement Base (xyz) of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement.Base                                          # Placement Vector XYZ
App.Console.PrintMessage("PlacementBase  : "+str(pl)+"\n\n")
##################################################################################
 
# give the placement Base (xyz) of the object selected
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
oripl_X = sel[0].Placement.Base[0]                                        # decode Placement X
oripl_Y = sel[0].Placement.Base[1]                                        # decode Placement Y
oripl_Z = sel[0].Placement.Base[2]                                        # decode Placement Z

# same 
#oripl_X = sel[0].Placement.Base.x                                        # decode Placement X
#oripl_Y = sel[0].Placement.Base.y                                        # decode Placement Y
#oripl_Z = sel[0].Placement.Base.z                                        # decode Placement Z
 
App.Console.PrintMessage("oripl_X        : "+str(oripl_X)+"\n")
App.Console.PrintMessage("oripl_Y        : "+str(oripl_Y)+"\n")
App.Console.PrintMessage("oripl_Z        : "+str(oripl_Z)+"\n\n")
##################################################################################

# give the placement rotation of the object selected (x, y, z, angle rotation)
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
rotation = sel[0].Placement.Rotation                                      # decode Placement Rotation
App.Console.PrintMessage("rotation              : "+str(rotation)+"\n\n")
##################################################################################

# give the placement rotation of the object selected (x, y, z, angle rotation)
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement.Rotation                                      # decode Placement Rotation other method
App.Console.PrintMessage("Placement Rot         : "+str(pl)+"\n\n")
##################################################################################

# give the rotation of the object selected (angle rotation)
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement.Rotation.Angle                                # decode Placement Rotation Angle
App.Console.PrintMessage("Placement Rot Angle   : "+str(pl)+"\n\n")
##################################################################################

# give the rotation.Q of the object selected (angle rotation in Radian) for convert: math.degrees(angleInRadian)
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
Rot   = sel[0].Placement.Rotation.Q                                       # Placement Rotation Q
App.Console.PrintMessage("Rot           : "+str(Rot)+ "\n")
 
Rot_0 = sel[0].Placement.Rotation.Q[0]                                    # decode Placement Rotation Q
App.Console.PrintMessage("Rot_0         : "+str(Rot_0)+ " rad ,  "+str(180 * Rot_0 / 3.1416)+" deg "+"\n") # or math.degrees(angle)
 
Rot_1 = sel[0].Placement.Rotation.Q[1]                                    # decode Placement Rotation 1
App.Console.PrintMessage("Rot_1         : "+str(Rot_1)+ " rad ,  "+str(180 * Rot_1 / 3.1416)+" deg "+"\n") # or math.degrees(angle)
 
Rot_2 = sel[0].Placement.Rotation.Q[2]                                    # decode Placement Rotation 2
App.Console.PrintMessage("Rot_2         : "+str(Rot_2)+ " rad ,  "+str(180 * Rot_2 / 3.1416)+" deg "+"\n") # or math.degrees(angle)

Rot_3 = sel[0].Placement.Rotation.Q[3]                                    # decode Placement Rotation 3
App.Console.PrintMessage("Rot_3         : "+str(Rot_3)+"\n\n")

Rot_Axis = sel[0].Placement.Rotation.Axis                                 # Placement Rotation .Axis
App.Console.PrintMessage("Rot_Axis      : "+str(Rot_Axis)+ "\n")
 
Rot_Angle = sel[0].Placement.Rotation.Angle                               # Placement Rotation .Angle
App.Console.PrintMessage("Rot_Angle     : "+str(Rot_Angle)+ "\n\n")
##################################################################################

# give the rotation of the object selected toEuler (angle rotation in degrees)
sel = FreeCADGui.Selection.getSelection()                             # select object with getSelection()
angle   = sel[0].Shape.Placement.Rotation.toEuler()                   # angle Euler
App.Console.PrintMessage("Angle          : "+str(angle)+"\n")
Yaw   = sel[0].Shape.Placement.Rotation.toEuler()[0]                  # decode angle Euler Yaw (Z) lacet (alpha)
App.Console.PrintMessage("Yaw            : "+str(Yaw)+"\n")
Pitch = sel[0].Shape.Placement.Rotation.toEuler()[1]                  # decode angle Euler Pitch (Y) tangage (beta)
App.Console.PrintMessage("Pitch          : "+str(Pitch)+"\n")
Roll  = sel[0].Shape.Placement.Rotation.toEuler()[2]                  # decode angle Euler Roll (X) roulis (gamma)
App.Console.PrintMessage("Roll           : "+str(Roll)+"\n\n")
##################################################################################

# find Midpoint of the selected line
import Draft, DraftGeomUtils
sel = FreeCADGui.Selection.getSelection()
vecteur = DraftGeomUtils.findMidpoint(sel[0].Shape.Edges[0])              # find Midpoint
App.Console.PrintMessage(vecteur)
Draft.makePoint(vecteur)
##################################################################################

Recherche d'un élément en donnant son Label

# Extract the coordinate X,Y,Z and Angle giving the label (here "Cylindre")
App.Console.PrintMessage("Base.x       : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.x)+"\n")
App.Console.PrintMessage("Base.y       : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.y)+"\n")
App.Console.PrintMessage("Base.z       : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.z)+"\n")
App.Console.PrintMessage("Base.Angle   : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Rotation.Angle)+"\n\n")
##################################################################################

PS: Les angles sont affichés en Radian, pour la convertir un radian en degrés faites :

  1. angle en Degrés vers Radians :
    • Angle en radian = pi * (angle en Degrés) / 180
    • Angle en radian = math.radians(angle en Degrés )
  2. angle en Radians vers Degrés :
    • Angle en Degrés = 180 * (angle en radian) / pi
    • Angle en Degrés = math.degrees(angle en radian)

Coordonnées Cartésiennes

Ce code affiche les coordonnées cartésiennes de l'objet sélectionné.

Changer la valeur "numberOfPoints" si vous voulez plus ou moins de précision

numberOfPoints = 100                                                         # Decomposition number (or precision you can change)
selectedEdge = FreeCADGui.Selection.getSelectionEx()[0].SubObjects[0].copy() # select one element
points  = selectedEdge.discretize(numberOfPoints)                            # discretize the element
i=0
for p in points:                                                             # list and display the coordinates
    i+=1
    print i, " X", p.x, " Y", p.y, " Z", p.z

Autre méthode d'affichage "Int" et "Float"

import Part
from FreeCAD import Base

c=Part.makeCylinder(2,10)        # create the circle
Part.show(c)                     # display the shape

# slice accepts two arguments:
#+ the normal of the cross section plane
#+ the distance from the origin to the cross section plane. Here you have to find a value so that the plane intersects your object
s=c.slice(Base.Vector(0,1,0),0)  # 

# here the result is a single wire
# depending on the source object this can be several wires
s=s[0]

# if you only need the vertexes of the shape you can use
v=[]
for i in s.Vertexes:
    v.append(i.Point)

# but you can also sub-sample the section to have a certain number of points (int) ...
p1=s.discretize(20)
ii=0
for i in p1:
    ii+=1
    print i                                              # Vector()
    print ii, ": X:", i.x, " Y:", i.y, " Z:", i.z        # Vector decode
Draft.makeWire(p1,closed=False,face=False,support=None)  # to see the difference accuracy (20)

## uncomment to use
#import Draft
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # first transform the DWire in Wire         "downgrade"
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # second split the Wire in single objects   "downgrade"
#
##Draft.upgrade(FreeCADGui.Selection.getSelection(),delete=True) # to attach lines contiguous SELECTED use "upgrade"


# ... or define a sampling distance (float)
p2=s.discretize(0.5)
ii=0
for i in p2:
    ii+=1
    print i                                              # Vector()
    print ii, ": X:", i.x, " Y:", i.y, " Z:", i.z        # Vector decode 
Draft.makeWire(p2,closed=False,face=False,support=None)  # to see the difference accuracy (0.5)

## uncomment to use
#import Draft
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # first transform the DWire in Wire         "downgrade"
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # second split the Wire in single objects   "downgrade"
#
##Draft.upgrade(FreeCADGui.Selection.getSelection(),delete=True) # to attach lines contiguous SELECTED use "upgrade"

Sélectionne tous les objets du document

import FreeCAD
for obj in FreeCAD.ActiveDocument.Objects:
    print obj.Name                                # display the object Name
    objName = obj.Name
    obj = App.ActiveDocument.getObject(objName)
    Gui.Selection.addSelection(obj)               # select the object

Sélectionner une face d'un objet

# select one face of the object
import FreeCAD, Draft
App=FreeCAD
nameObject = "Box"                             # objet
faceSelect = "Face3"                           # face to selection
loch=App.ActiveDocument.getObject(nameObject)  # objet
Gui.Selection.clearSelection()                 # clear all selection
Gui.Selection.addSelection(loch,faceSelect)    # select the face specified
s = Gui.Selection.getSelectionEx()
#Draft.makeFacebinder(s)                       #

Créer un objet dans la position de la camera

# create one object of the position to camera with "getCameraOrientation()"
# the object is still facing the screen
import Draft

plan = FreeCADGui.ActiveDocument.ActiveView.getCameraOrientation()
plan = str(plan)
###### extract data
a    = ""
for i in plan:
    if i in ("0123456789e.- "):
        a+=i
a = a.strip(" ")
a = a.split(" ")
####### extract data

#print a
#print a[0]
#print a[1]
#print a[2]
#print a[3]

xP = float(a[0])
yP = float(a[1])
zP = float(a[2])
qP = float(a[3])

pl = FreeCAD.Placement()
pl.Rotation.Q = (xP,yP,zP,qP)         # rotation of object
pl.Base = FreeCAD.Vector(0.0,0.0,0.0) # here coordinates XYZ of Object
rec = Draft.makeRectangle(length=10.0,height=10.0,placement=pl,face=False,support=None) # create rectangle
#rec = Draft.makeCircle(radius=5,placement=pl,face=False,support=None)                   # create circle
print rec.Name

Ici le même code simplifié

import Draft
pl = FreeCAD.Placement()
pl.Rotation = FreeCADGui.ActiveDocument.ActiveView.getCameraOrientation()
pl.Base = FreeCAD.Vector(0.0,0.0,0.0)
rec = Draft.makeRectangle(length=10.0,height=10.0,placement=pl,face=False,support=None)

Recherche du vecteur normal() sur une surface

Cet exemple montre comment trouver le vecteur normal() d'une face en cherchant les paramètres uv d'un point sur la surface et utiliser les paramètres u, v pour trouver le vecteur normal()

def normal(self):
   ss=FreeCADGui.Selection.getSelectionEx()[0].SubObjects[0].copy()#SubObjects[0] is the edge list
   points  = ss.discretize(3.0)#points on the surface edge, 
             #this example just use points on the edge for example. 
             #However point is not necessary on the edge, it can be anywhere on the surface. 
   face=FreeCADGui.Selection.getSelectionEx()[0].SubObjects[1]
   for pp in points:
      pt=FreeCAD.Base.Vector(pp.x,pp.y,pp.z)#a point on the surface edge
      uv=face.Surface.parameter(pt)# find the surface u,v parameter of a point on the surface edge
      u=uv[0]
      v=uv[1]
      normal=face.normalAt(u,v)#use u,v to find normal vector
      print normal
      line=Part.makeLine((pp.x,pp.y,pp.z), (normal.x,normal.y,normal.z))
      Part.show(line)

Lire et écrire une Expression

import Draft
doc = FreeCAD.ActiveDocument

pl=FreeCAD.Placement()
pl.Rotation.Q=(0.0,-0.0,-0.0,1.0)
pl.Base=FreeCAD.Vector(0.0,0.0,0.0)
obj = Draft.makeCircle(radius=1.0,placement=pl,face=False,support=None)    # create circle

print obj.PropertiesList                                                   # properties disponible in the obj

doc.getObject(obj.Name).setExpression('Radius', u'2mm')                    # modify the radius
doc.getObject(obj.Name).setExpression('Placement.Base.x', u'10mm')         # modify the placement 
doc.getObject(obj.Name).setExpression('FirstAngle', u'90')                 # modify the first angle
doc.recompute()

expressions = obj.ExpressionEngine                                         # read the expression list
print expressions

for i in expressions:                                                      # list and separate the data expression
    print i[0]," = ",i[1]

Obtenir le vecteur normal d'une surface à partir d'un fichier STL

def getNormal(cb):
    if cb.getEvent().getState() == coin.SoButtonEvent.UP:
        pp = cb.getPickedPoint()
        if pp:
            vec = pp.getNormal().getValue()
            index = coin.cast(pp.getDetail(), "SoFaceDetail").getFaceIndex()
            print ("Normal: {}, Face index: {}".format(str(vec), index))

from pivy import coin
meth=Gui.ActiveDocument.ActiveView.addEventCallbackPivy(coin.SoMouseButtonEvent.getClassTypeId(), getNormal)

Vous avez terminé et voulez quitter :

Gui.ActiveDocument.ActiveView.removeEventCallbackPivy(coin.SoMouseButtonEvent.getClassTypeId(), meth)
Arrow-left.svg Page précédente: Incorporer FreeCAD
Page suivante: Fonction Line drawing Arrow-right.svg